Difference between revisions of "Mesh to Part/fr"

From FreeCAD Documentation
Jump to navigation Jump to search
(Updating to match new version of source page)
 
(3 intermediate revisions by one other user not shown)
Line 5: Line 5:
 
}}
 
}}
  
== Conversion d'objets Pièces en Maillages ==
+
== Conversion d'objets Part en maillages ==
  
 
La conversion des objets de haut niveau tels que les objets ([[Part Module/fr|formes]]) en objets simples comme les [[Mesh Module/fr|maillages]] (Mesh) est une opération facile, où, toutes les faces d'un Objet Part deviennent une composition de triangles [http://www.coin3d.org/usage/casestudies/users/usageexample.2008-05-30.6001136448/4DVista.PNG (exemple sur le site de coin3d un des moteurs de FreeCAD)].<br />
 
La conversion des objets de haut niveau tels que les objets ([[Part Module/fr|formes]]) en objets simples comme les [[Mesh Module/fr|maillages]] (Mesh) est une opération facile, où, toutes les faces d'un Objet Part deviennent une composition de triangles [http://www.coin3d.org/usage/casestudies/users/usageexample.2008-05-30.6001136448/4DVista.PNG (exemple sur le site de coin3d un des moteurs de FreeCAD)].<br />
Line 44: Line 44:
 
return mesh
 
return mesh
 
}}
 
}}
== Conversion de Mailles en Part objects ==
+
== Conversion de maillages en objet Part ==
  
 
La conversion des mailles en Part objets est une opération extrêmement importante en CAO, car, très souvent vous recevrez des données 3D au format Mesh (maillage) à partir d'autres utilisateurs ou émis par d'autres applications de CAO. Les Mailles sont très pratiques pour représenter les formes géométriques libres et de grandes scènes visuelles, car il est très léger, mais pour la CAO nous préférons généralement des objets de niveau supérieur qui portent beaucoup plus d'informations comme, l'idée de solides, ou faces sont faites de courbes au lieu de triangles.
 
La conversion des mailles en Part objets est une opération extrêmement importante en CAO, car, très souvent vous recevrez des données 3D au format Mesh (maillage) à partir d'autres utilisateurs ou émis par d'autres applications de CAO. Les Mailles sont très pratiques pour représenter les formes géométriques libres et de grandes scènes visuelles, car il est très léger, mais pour la CAO nous préférons généralement des objets de niveau supérieur qui portent beaucoup plus d'informations comme, l'idée de solides, ou faces sont faites de courbes au lieu de triangles.
Line 53: Line 53:
 
La première méthode est simple, la conversion directe, sans aucune optimisation:
 
La première méthode est simple, la conversion directe, sans aucune optimisation:
 
{{Code|code=
 
{{Code|code=
import Mesh,Part
+
import Mesh
 +
import Part
 +
 
 
mesh = Mesh.createTorus()
 
mesh = Mesh.createTorus()
 
shape = Part.Shape()
 
shape = Part.Shape()
Line 59: Line 61:
 
solid = Part.makeSolid(shape)
 
solid = Part.makeSolid(shape)
 
Part.show(solid)
 
Part.show(solid)
 +
}}
  
}}
 
 
La seconde méthode, offre la possibilité d'examiner les aspects de mailles coplanaires, lorsque l'angle entre eux est sous une certaine valeur.
 
La seconde méthode, offre la possibilité d'examiner les aspects de mailles coplanaires, lorsque l'angle entre eux est sous une certaine valeur.
 
Cela permet de construire des formes beaucoup plus simples:
 
Cela permet de construire des formes beaucoup plus simples:
 
{{Code|code=
 
{{Code|code=
 
# let's assume our document contains one Mesh object
 
# let's assume our document contains one Mesh object
import Mesh,Part,MeshPart
+
import Mesh
 +
import Part
 +
import MeshPart
 +
 
 
faces = []
 
faces = []
 
mesh = App.ActiveDocument.ActiveObject.Mesh
 
mesh = App.ActiveDocument.ActiveObject.Mesh
Line 76: Line 81:
 
     # we assume that the exterior boundary is that one with the biggest bounding box
 
     # we assume that the exterior boundary is that one with the biggest bounding box
 
     if len(wires) > 0:
 
     if len(wires) > 0:
         ext=None
+
         ext = None
 
         max_length=0
 
         max_length=0
 
         for i in wires:
 
         for i in wires:
Line 92: Line 97:
 
         faces.append(Part.Face(wires))
 
         faces.append(Part.Face(wires))
  
shell=Part.Compound(faces)
+
shell = Part.Compound(faces)
 
Part.show(shell)
 
Part.show(shell)
#solid = Part.Solid(Part.Shell(faces))
+
# solid = Part.Solid(Part.Shell(faces))
#Part.show(solid)
+
# Part.show(solid)
 
+
}}
 +
{{docnav/fr
 +
|[[Topological data scripting/fr|Script pour les pièces]]
 +
|[[Scenegraph/fr|Scène graphique]]
 
}}
 
}}
{{docnav/fr|[[Topological data scripting/fr|Topological data scripting]]|[[Scenegraph/fr|Scenegraph]]}}
 
  
{{Userdocnavi{{#translation:}}}}
+
{{Powerdocnavi{{#translation:}}}}
[[Category:Poweruser Documentation{{#translation:}}]]
 
 
[[Category:Python Code{{#translation:}}]]
 
[[Category:Python Code{{#translation:}}]]

Latest revision as of 10:58, 24 May 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎română • ‎svenska • ‎čeština • ‎русский • ‎日本語
Arrow-left.svg Page précédente: Script pour les pièces
Page suivante: Scène graphique Arrow-right.svg

Conversion d'objets Part en maillages

La conversion des objets de haut niveau tels que les objets (formes) en objets simples comme les maillages (Mesh) est une opération facile, où, toutes les faces d'un Objet Part deviennent une composition de triangles (exemple sur le site de coin3d un des moteurs de FreeCAD).
Le résultat de cette triangulation (tessellation) est ensuite utilisé pour construire un maillage (Mesh):

#let's assume our document contains one part object
import Mesh
faces = []
shape = FreeCAD.ActiveDocument.ActiveObject.Shape
triangles = shape.tessellate(1) # the number represents the precision of the tessellation)
for tri in triangles[1]:
    face = []
    for i in range(3):
        vindex = tri[i]
        face.append(triangles[0][vindex])
    faces.append(face)
m = Mesh.Mesh(faces)
Mesh.show(m)

Parfois, la triangulation de certaines faces offertes par OpenCascade sont assez laid. Si une face a un forme rectangulaire et ne contient pas de trous ou n'est pas limité par des courbes, vous pouvez également créer un maillage sur cette forme:

import Mesh
def makeMeshFromFace(u,v,face):
	(a,b,c,d)=face.ParameterRange
	pts=[]
	for j in range(v):
		for i in range(u):
			s=1.0/(u-1)*(i*b+(u-1-i)*a)
			t=1.0/(v-1)*(j*d+(v-1-j)*c)
			pts.append(face.valueAt(s,t))

	mesh=Mesh.Mesh()
	for j in range(v-1):
		for i in range(u-1):
			mesh.addFacet(pts[u*j+i],pts[u*j+i+1],pts[u*(j+1)+i])
			mesh.addFacet(pts[u*(j+1)+i],pts[u*j+i+1],pts[u*(j+1)+i+1])

	return mesh

Conversion de maillages en objet Part

La conversion des mailles en Part objets est une opération extrêmement importante en CAO, car, très souvent vous recevrez des données 3D au format Mesh (maillage) à partir d'autres utilisateurs ou émis par d'autres applications de CAO. Les Mailles sont très pratiques pour représenter les formes géométriques libres et de grandes scènes visuelles, car il est très léger, mais pour la CAO nous préférons généralement des objets de niveau supérieur qui portent beaucoup plus d'informations comme, l'idée de solides, ou faces sont faites de courbes au lieu de triangles.

La conversion des mailles en un de ces objets de niveau supérieur (gérée par le Part Module dans FreeCAD) n'est pas une opération facile. Les Mailles peuvent êtres faites de milliers de triangles (par exemple lorsqu'ils sont générés par un scanner 3D), et des solides faits du même nombre de faces serait extrêmement lourd à manipuler. Donc, vous voudrez généralement voir l'objet optimisé lors de la conversion.

FreeCAD propose actuellement deux méthodes pour convertir des Parts objets en mailles. La première méthode est simple, la conversion directe, sans aucune optimisation:

import Mesh
import Part

mesh = Mesh.createTorus()
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
solid = Part.makeSolid(shape)
Part.show(solid)

La seconde méthode, offre la possibilité d'examiner les aspects de mailles coplanaires, lorsque l'angle entre eux est sous une certaine valeur. Cela permet de construire des formes beaucoup plus simples:

# let's assume our document contains one Mesh object
import Mesh
import Part
import MeshPart

faces = []
mesh = App.ActiveDocument.ActiveObject.Mesh
segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
 
for i in segments:
  if len(i) > 0:
     # a segment can have inner holes
     wires = MeshPart.wireFromSegment(mesh, i)
     # we assume that the exterior boundary is that one with the biggest bounding box
     if len(wires) > 0:
        ext = None
        max_length=0
        for i in wires:
           if i.BoundBox.DiagonalLength > max_length:
              max_length = i.BoundBox.DiagonalLength
              ext = i

        wires.remove(ext)
        # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
        for i in wires:
           i.reverse()

        # make sure that the exterior wires comes as first in the list
        wires.insert(0, ext)
        faces.append(Part.Face(wires))

shell = Part.Compound(faces)
Part.show(shell)
# solid = Part.Solid(Part.Shell(faces))
# Part.show(solid)
Arrow-left.svg Page précédente: Script pour les pièces
Page suivante: Scène graphique Arrow-right.svg

Template:Powerdocnavi/fr